#include "calc_convolve.h"

int main(int argc, char *argv[])
{
  int count1, count2, sigma;
  double delta_lam, sigma_lam, sigma2_2_i, dlamsqrt2pisigma2_i, tmp;
  vector<double> lambda, flux;

  if (argc != 3) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: calc_convolve input_file sigma(in pixel)\n";
    return 1;
  }

  ifstream fin(argv[1]);
  if(!fin) {
    cout << "Cannot open " << argv[1] << ".\n";
    return 1;
  }

  while (fin) {
    fin >> tmp;
    lambda.push_back(tmp);
    fin >> tmp;
    flux.push_back(tmp);
  }
  fin.close();

  sigma = atoi(argv[2]);
  delta_lam = lambda[1] - lambda[0];
  sigma_lam = (double)sigma * delta_lam;

  sigma2_2_i = 1 / (2 * func_square(sigma_lam));
  dlamsqrt2pisigma2_i = delta_lam / (sqrt(2 * pi) * sigma_lam);

  cout.precision(10);

  for (count1 = 0; count1 < (int)flux.size() - 1; count1++) {
    tmp = 0;

    for (count2 = count1 - 3 * sigma; count2 < count1 + 3 * sigma; count2++) {
      if (count2 < 0 || count2 > (int)flux.size() - 1) continue;

      tmp += flux[count2] * exp(-func_square(lambda[count2] - lambda[count1]) * sigma2_2_i);
      }

    cout << lambda[count1] << " " << tmp * dlamsqrt2pisigma2_i << "\n";  
  }

  return 0;
}
