#include <iostream>
#include <cstdlib>
#include <cmath>
using namespace std;

static const double pi = 3.14159265358979323;
static const double degree_to_radian = pi / 180.0;
static const double radian_to_degree = 180.0 / pi;

int main(int argc, char *argv[])
{
  if (argc != 5) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: calc_separation_cpp RA1 Dec1 RA2 Dec2 (in degree)\n";
    return 1;
  }

// conversion between degree and radian
  
  double coord1_RA_rad, coord1_Dec_rad, coord2_RA_rad, coord2_Dec_rad;
  coord1_RA_rad = atof(argv[1]) * degree_to_radian;
  coord1_Dec_rad = atof(argv[2]) * degree_to_radian;
  coord2_RA_rad = atof(argv[3]) * degree_to_radian;
  coord2_Dec_rad = atof(argv[4]) * degree_to_radian;

  cout << acos(cos(coord1_Dec_rad) * cos(coord1_RA_rad) * cos(coord2_Dec_rad) * cos(coord2_RA_rad) + cos(coord1_Dec_rad) * sin(coord1_RA_rad) * cos(coord2_Dec_rad) * sin(coord2_RA_rad) + sin(coord1_Dec_rad) * sin(coord2_Dec_rad)) * radian_to_degree << "\n";

  return 0;
}

