#include "func_fp.h"

double fp_trans(const double finesse, const double obs_lambda,
  const double lambda, const int order)
{
  return 1.0 / (1.0 + (2.0 * finesse / pi) * (2.0 * finesse / pi) *
    (sin((double)order * pi * obs_lambda / lambda)) * (sin((double)order * pi
    * obs_lambda / lambda)));
}

double linear_approx(const double x, const double x1, const double x2,
  const double y1, const double y2)
{
  return (y2 - y1) / (x2 - x1) * (x - x1) + y1;
}

double calc_convolve(const double finesse, const double lambda_obs,
  const int order, const vector<double> lambda_sstar,
  const vector<double> flux_sstar)
{
  int count1, count2 = 0, count_max = 10000;
  double flux_convolve = 0, lambda_calc, lambda_diff = 0.01;

  for(count1 = 0; count1 <= count_max; count1++) {
    lambda_calc = lambda_obs + (double)(count1 - count_max / 2) * lambda_diff;

    while(lambda_sstar[count2] < lambda_calc) {
      count2++;
    }
    flux_convolve += linear_approx(lambda_calc, lambda_sstar[count2],
      lambda_sstar[count2 + 1], flux_sstar[count2], flux_sstar[count2 + 1])
      * fp_trans(finesse, lambda_obs, lambda_calc, order) * lambda_diff;
  }

  return flux_convolve;
}

double return_convert(const double eggr_lambda[], const double eggr_convert[],
  int num_max, double lambda_obs)
{
  int count1;

  for (count1 = 2; count1 <= num_max; count1++) {
    if (lambda_obs < eggr_lambda[count1] || count1 == num_max) {
      return linear_approx(lambda_obs, eggr_lambda[count1 - 1], 
        eggr_lambda[count1], eggr_convert[count1 - 1], eggr_convert[count1]);
    }
  }
  return 0;
}
