#ifndef _FP_DRIFT_TIME_H

#define _FP_DRIFT_TIME_H

#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

static const int num_sstar_data = 10000, num_obs_data = 100, num_read_write = 4096;
static const double pi = 3.14159, v_light = 299792.458, v_light_i = 1 / v_light;

int file_input1(const char *filename, double data1[], int *num_max);
int file_input2(const char *filename, double data1[], double data2[],
  int *num_max);
int file_output1(const char *filename, const double data1[], const int num_max);
double fp_trans(const double finesse, const double obs_lambda,
  const double lambda, const int order);
double linear_approx(const double x, const double x1, const double x2,
  const double y1, const double y2);
double calc_convolve(const double finesse, const double lambda_obs,
  const int order, const vector<double> lambda_sstar, const vector<double> flux_sstar);
double return_convert(const double eggr_lambda[], const double eggr_convert[],
  int num_max, double lambda_obs);

#endif
