#ifndef _FUNC_MATH_H

#define _FUNC_MATH_H

#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;

void calc_azi_elev(const double gmst_hour, const double obj_RA_Dec[], const double long_lat[], vector<double> &azi_elev);

double func_center(vector<double> data, int naxis1, int naxis2, int init_x, int init_y, int range, int axis);
double func_box_flux(vector<double> data, int naxis1, int naxis2, double center_x, double center_y, int range);
double func_rotate_x(double input_x, double input_y, double center_x, double center_y, double rotate);
double func_rotate_y(double input_x, double input_y, double center_x, double center_y, double rotate);
void func_v_sigma(const vector<double> &v_input, vector<double> &v_output);
double func_median(vector<double> data);
double func_mean(vector<double> data);
double func_stddev(vector<double> data);
double func_linear_approx(double x1, double x2, double y1, double y2, double x);
double func_square(double x);

#endif
