#ifndef _FIBER_DETECT_COSMIC_DIFF_H

#define _FIBER_DETECT_COSMIC_DIFF_H

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include <vector>
using namespace std;

static const int char_length = 4096, check_buff = 3;

void get_naxis(char *get_frame, int naxis[]);
void open_fitsfile(char *in_filename, int naxis1, int naxis2, double data[]);
int read_header(const char *in_filename, const char *header_keyword, char *char_return);
void create_fitsfile(char *h_filename, char *out_filename, int naxis1, int naxis2, double data[]);

double func_stddev(vector<double> data);
double func_mean(vector<double> data);
double func_linear_approx(double x1, double x2, double y1, double y2, double x);

void input_v_tmp_x(vector<double> &v_input, vector<double> &v_output, int x, int y, int naxis1);
void input_v_tmp_x2(vector<double> &v_input, vector<double> &v_output, int x, int y, int naxis1);
void input_v_tmp_y(vector<double> &v_input, vector<double> &v_output, int x, int y, int naxis1);
void input_v_tmp_y2(vector<double> &v_input, vector<double> &v_output, int x, int y, int naxis1);
void remove_cosmicrays(vector<double> &v_data_in, vector<double> &v_data_out, vector<int> &v_flag, int naxis[], int check_buff);

#endif
