#include "FiberGaussTmpl.h"

int main(int argc, char *argv[])
{
  int count1, count2, count3, count4, count5, count6;
  int offset_x[7] = {-1, 1, -2, 0, 2, -1, 1}, offset_y[7] = {2, 2, 0, 0, 0, -2, -2};
  double pos_x, pos_y, xc, yc, dx, dy, total = 0, sigma, sigma2double, FWHM;
  
/* initialize */

  dx = dy = 2 * core_clad_ratio / total_step; // clad radius = 1

  cout << "#fiber_id pos_x pos_y FWHM flux\n";

  for(count4 = 0; count4 < 38; count4++) {
    FWHM = ((double)count4 * 0.1 + 0.3) * 2;
    sigma = FWHM / sqrt(8 * log(2));
    sigma2double = sigma * sigma * 2;

    for(count3 = 0; count3 < 7; count3++) {

      for(count2 = 0; count2 < 11; count2++) {
        for(count1 = 0; count1 < 11; count1++) {
          pos_x = count1 * 0.2 - 1.0;
          pos_y = count2 * 0.2 - 1.0;

          for(count5 = 0; count5 < total_step; count5++) {
            yc = ((double)count5 - (double)total_step * 0.5 + 0.5) * dy;
            for(count6 = 0; count6 < total_step; count6++) {
              xc = ((double)count6 - (double)total_step * 0.5 + 0.5) * dx;

              if(func_square(xc) + func_square(yc) <= func_square(core_clad_ratio)) {
                total += exp(-((func_square(xc - pos_x + offset_x[count3]) + func_square(yc + (-pos_y + offset_y[count3]) * sqrt(3) * 0.5)) / sigma2double));
              }
            }
          }

          cout << count3 << " " << pos_x << " " << pos_y << " " << FWHM << " " << total * dx * dy / (pi * sigma2double) << "\n";
          total = 0;
        }
      }
    }
  }

  return 0;
}
