#include "FiberGravity.h"

int main(int argc, char *argv[])
{
  if (argc != 3) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: FiberGravity input_fits bias_value.\n";
    return 1;
  }

  int count1, count2;
  double *get_data, pos_x, pos_y, gravity_x = 0, gravity_y = 0, bias = atof(argv[2]), total_flux = 0;
  vector<double> obs_data;
  char obs_frame[char_length];
  
  get_data = new double [naxis1_in * naxis2_in];
  if (!get_data) {
    cout << "Memory error.\n";
    return 2;
  }

/* open input fits file */

  strcpy (obs_frame, argv[1]);

  open_fitsfile(obs_frame, naxis1_in, naxis2_in, get_data);
  for (count1 = 0; count1 < naxis1_in * naxis2_in; count1++) {
    obs_data.push_back(get_data[count1] - bias);
    }

  delete [] get_data;

/* calculate gravity center */

  for(count2 = 1; count2 <= 7; count2++) {
    for(count1 = 1; count1 < 7 + count2; count1++) {
      pos_x = count1 * 2 - count2 - 7;
      pos_y = 14 - count2 * 2;

      total_flux += obs_data[(pos_x + 12) + (pos_y + 12) * naxis2_in];
      gravity_x += (double)pos_x * obs_data[(pos_x + 12) + (pos_y + 12) * naxis2_in];
      gravity_y += (double)pos_y * obs_data[(pos_x + 12) + (pos_y + 12) * naxis2_in];
    }
  }

  for(count2 = 1; count2 <= 6; count2++) {
    for(count1 = 1; count1 < 14 - count2; count1++) {
      pos_x = count1 * 2 + count2 - 14;
      pos_y = - count2 * 2;

      total_flux += obs_data[(pos_x + 12) + (pos_y + 12) * naxis2_in];
      gravity_x += (double)pos_x * obs_data[(pos_x + 12) + (pos_y + 12) * naxis2_in];
      gravity_y += (double)pos_y * obs_data[(pos_x + 12) + (pos_y + 12) * naxis2_in];
    }
  }

  gravity_x /= total_flux * 2;
  gravity_y /= total_flux * 2;

  cout.precision(3);
  cout << "gravity (x, y) = (" << fixed << gravity_x << ", " << fixed << gravity_y << ")\n";

  return 0;
}
