#ifndef _FIBER_IMAGE_REAL_H

#define _FIBER_IMAGE_REAL_H

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include "fitsio.h"
using namespace std;

static const int char_length = 4096, naxis1_in = 25, naxis2_in = 25, num_fiber = 127;
static const int image_max_x = 1625, image_max_y = 1407, image_offset_y = 100;
static const double sqrt3_div2 = sqrt(3) / 2, pi = 3.14159265359;
static const double r_fiber = 62.5, r_core = 50, image_center_x = ((double)image_max_x + 1) / 2, image_center_y = ((double)image_max_y + 1) / 2;
static const double kools_ifu_rotate = 127.3 / 180 * pi;
//static const double rotate = -127.3 / 180 * pi;
//static const double rotate = 0;

void open_fitsfile(char *in_filename, int naxis1, int naxis2, double data[]);
double func_rotate_x(double input_x, double input_y, double center_x, double center_y, double rotate);
double func_rotate_y(double input_x, double input_y, double center_x, double center_y, double rotate);

#endif
