#include "FiberMakeImage.h"

int main(int argc, char *argv[])
{
  if (argc != 4) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: FiberMakeImage input_fits start_x end_x.\n";
    return 1;
  }

  int count1, count2, tmp = 0, naxis_in[3];
  int start_x = atoi(argv[2]) - 1, end_x = atoi(argv[3]) - 1, fiber_pos_x[num_fiber], fiber_pos_y[num_fiber];
  double *get_data, *out_data, sum_flux = 0;
  vector<double> obs_data, fiber_flux;
  char obs_frame[char_length], out_frame[char_length], *dot_position;
  
  out_data = new double [naxis1_out * naxis2_out];
  if (!out_data) {
    cout << "Memory error.\n";
    return 2;
  }

/* open input fits file */

  strcpy (obs_frame, argv[1]);

  get_naxis(obs_frame, naxis_in);

  get_data = new double [naxis_in[1] * naxis_in[2]];
  if (!get_data) {
    cout << "Memory error.\n";
    return 2;
  }

  open_fitsfile(obs_frame, naxis_in[1], naxis_in[2], get_data);
  for (count1 = 0; count1 < naxis_in[1] * naxis_in[2]; count1++) {
    obs_data.push_back(get_data[count1]);
  }

/* set output file name */

  dot_position = strrchr(obs_frame, '.');

  strncpy(out_frame, obs_frame, strlen(obs_frame) - strlen(dot_position));
//  strcat(out_frame, "-image.fits");
  sprintf(out_frame, "%s-image-%d-%d.fits", out_frame, start_x + 1, end_x + 1);
  remove(out_frame);

/* calculate fiber flux */

  for(count2 = 0; count2 < naxis_in[2]; count2++) {
    for(count1 = start_x; count1 <= end_x; count1++) {
      sum_flux += get_data[count1 + count2 * naxis_in[1]];
    }
    fiber_flux.push_back(sum_flux);
    sum_flux = 0;
  }

/* fiber position library */

  for(count2 = 1; count2 <= 7; count2++) {
    for(count1 = 1; count1 < 7 + count2; count1++) {
      fiber_pos_x[count1 + tmp] = count1 * 2 + 6 - count2;
      fiber_pos_y[count1 + tmp] = 27 - count2 * 2;
    }
    tmp += count1 - 1;
//    cout << "tmp = " << tmp << "\n";
  }

  for(count2 = 1; count2 <= 6; count2++) {
    for(count1 = 1; count1 < 14 - count2; count1++) {
      fiber_pos_x[count1 + tmp] = count1 * 2 + count2 - 1;
      fiber_pos_y[count1 + tmp] = 13 - count2 * 2;
    }
    tmp += count1 - 1;
//    cout << "tmp = " << tmp << "\n";
  }

/* align in fiberbundle format */

  for(count1 = 0; count1 < naxis1_out * naxis2_out; count1++) out_data[count1] = 0;

  for(count1 = 0; count1 < naxis_in[2]; count1++) {
    out_data[fiber_pos_x[fiber_id[count1]] - 1 + naxis2_out * (fiber_pos_y[fiber_id[count1]] - 1)] = fiber_flux[count1];
  }

/* output image file */

  create_fitsfile(obs_frame, out_frame, naxis1_out, naxis2_out, out_data);

  delete [] get_data;
  delete [] out_data;

  return 0;
}
