#include "FiberSpecToImage2.h"

int main(int argc, char *argv[])
{
  if (argc != 10) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: FiberSpecToImage2 input_tmpl_fits init_x init_y center_range bias_tmpl input_data_fits offset_x offset_y bias_data.\n";
    return 1;
  }

  int count1, count2, tmp = 0, naxis_tmpl[3], naxis_data[3];
  int center_range = atoi(argv[4]), binning = 2, fiber_pos_x[num_fiber], fiber_pos_y[num_fiber];
  double *get_tmpl, *get_data, *out_data;
  double center_x = atof(argv[2]) - 1, center_y = atof(argv[3]) - 1, init_tmp_y, offset_x = atof(argv[7]), offset_y = atof(argv[8]), previous_y = -10;
  double bias_tmpl = atof(argv[5]), bias_data = atof(argv[9]);
  vector<double> obs_data, tmpl_data, fiber_flux;
  char tmpl_frame[char_length], obs_frame[char_length], out_frame[char_length], *dot_position;
 
  out_data = new double [naxis1_out * naxis2_out];
  if (!out_data) {
    cout << "Memory error.\n";
    return 2;
  }

/* open template fits file */

  strcpy(tmpl_frame, argv[1]);

  get_naxis(tmpl_frame, naxis_tmpl);

  get_tmpl = new double [naxis_tmpl[1] * naxis_tmpl[2]];
  if (!get_tmpl) {
    cout << "Memory error.\n";
    return 2;
  }

  open_fitsfile(tmpl_frame, naxis_tmpl[1], naxis_tmpl[2], get_tmpl);
  for (count1 = 0; count1 < naxis_tmpl[1] * naxis_tmpl[2]; count1++) {
    tmpl_data.push_back(get_tmpl[count1] - bias_tmpl);
  }

/* open input fits file */

  strcpy (obs_frame, argv[6]);

  get_naxis(obs_frame, naxis_data);

  get_data = new double [naxis_data[1] * naxis_data[2]];
  if (!get_data) {
    cout << "Memory error.\n";
    return 2;
  }

  open_fitsfile(obs_frame, naxis_data[1], naxis_data[2], get_data);
  for (count1 = 0; count1 < naxis_data[1] * naxis_data[2]; count1++) {
    obs_data.push_back(get_data[count1] - bias_data);
  }

/* set output file name */

  dot_position = strrchr(obs_frame, '.');

  strncpy(out_frame, obs_frame, strlen(obs_frame) - strlen(dot_position));
  strcat(out_frame, "-image.fits");
  remove(out_frame);

/* calculate gravity center */

  for(count1 = 0; count1 < 127; count1++) {

    do {
      init_tmp_y = center_y;

      center_y = func_center(tmpl_data, naxis_tmpl[1], naxis_tmpl[2], (int)(center_x + 0.5), (int)(init_tmp_y + 0.5), center_range, 2);

  cout << "count1 = " << count1 << " center_y = " << center_y + 1 << " init_tmp_y = " << init_tmp_y + 1 << "\n";

    } while (abs(center_y - init_tmp_y) > 1 && center_y - previous_y > 4 / binning);

//    fout1 << init_x << " " << center_y << "\n";
    previous_y = center_y;

/* calculate fiber flux */

    fiber_flux.push_back(func_box_flux(obs_data, naxis_data[1], naxis_data[2], center_x + offset_x, center_y + offset_y, center_range));
    if (center_y + 1 >= naxis_data[2]) fiber_flux[count1] = 0;


//    cout << "count1 = " << count1 << " fiber_flux = " << fiber_flux[count1] << "\n";

    center_y += step_y / (double)binning;
    if(count1 == 41) center_y += 86 / (double)binning;
    if(count1 == 84) center_y += 86 / (double)binning;
  }

/* fiber position library */

  for(count2 = 1; count2 <= 7; count2++) {
    for(count1 = 1; count1 < 7 + count2; count1++) {
      fiber_pos_x[count1 + tmp] = count1 * 2 + 6 - count2;
      fiber_pos_y[count1 + tmp] = 27 - count2 * 2;
    }
    tmp += count1 - 1;
//    cout << "tmp = " << tmp << "\n";
  }

  for(count2 = 1; count2 <= 6; count2++) {
    for(count1 = 1; count1 < 14 - count2; count1++) {
      fiber_pos_x[count1 + tmp] = count1 * 2 + count2 - 1;
      fiber_pos_y[count1 + tmp] = 13 - count2 * 2;
    }
    tmp += count1 - 1;
//    cout << "tmp = " << tmp << "\n";
  }

/* align in fiberbundle format */

  for(count1 = 0; count1 < naxis1_out * naxis2_out; count1++) out_data[count1] = 0;

  for(count1 = 0; count1 < num_fiber; count1++) {
    out_data[fiber_pos_x[fiber_id[count1]] - 1 + naxis2_out * (fiber_pos_y[fiber_id[count1]] - 1)] = fiber_flux[count1];
  }

/* output image file */

  create_fitsfile(obs_frame, out_frame, naxis1_out, naxis2_out, out_data);

  delete [] get_tmpl;
  delete [] get_data;
  delete [] out_data;

  return 0;
}
