#ifndef _FIBER_SPOT_TO_IMAGE_H

#define _FIBER_SPOT_TO_IMAGE_H

#include <iostream>
#include <fstream>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <ctime>
#include "fitsio.h"
using namespace std;

static const int char_length = 4096, naxis1_in[3] = {0, 1050, 550}, naxis2_in[3] = {0, 1000, 500}, step_y[3] = {0, 6, 3}, naxis1_out = 25, naxis2_out = 25, num_fiber = 127;

static const int fiber_id[num_fiber] = {13, 34, 54, 7, 27, 107, 12, 29, 74, 19, 41, 63, 87, 43, 5, 3, 21, 85, 96, 32, 39, 115, 62, 20, 31, 66, 77, 6, 2, 50, 4, 42, 23, 51, 53, 30, 64, 17, 65, 15, 22, 14, 127, 118, 117, 122, 103, 104, 113, 125, 91, 111, 116, 121, 126, 102, 92, 100, 70, 110, 124, 24, 67, 55, 57, 120, 112, 79, 45, 88, 78, 82, 69, 99, 56, 119, 101, 108, 93, 123, 109, 81, 68, 89, 90, 86, 37, 38, 16, 10, 75, 61, 26, 105, 44, 71, 59, 60, 58, 106, 11, 25, 8, 1, 97, 33, 84, 73, 35, 94, 49, 95, 36, 47, 9, 80, 72, 114, 18, 76, 40, 52, 83, 48, 98, 28, 46};

void open_fitsfile(char *in_filename, int naxis1, int naxis2, double data[]);
void create_fitsfile(char *h_filename, char *out_filename, int naxis1, int naxis2, double data[]);

double func_center(vector<double> data, int naxis1, int naxis2, int init_x, int init_y, int range, int axis);
double func_box_flux(vector<double> data, int naxis1, int naxis2, double center_x, double center_y, int range);

#endif
