#include "FiberToImageTmpl.h"

int main(int argc, char *argv[])
{
  if (argc != 5) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: FiberToImageTmpl input_fits input_dat center_range bias_value.\n";
    return 1;
  }

  int count1, count2, naxis1_in, naxis2_in, tmp = 0;
  int center_range = atoi(argv[3]), fiber_pos_x[num_fiber], fiber_pos_y[num_fiber];
  double *get_data, *out_data, center_x, center_y, bias = atof(argv[4]);
  vector<double> obs_data, fiber_flux;
  char obs_frame[char_length], out_frame[char_length], pos_dat[char_length], *dot_position;
  
/* input parameter file */

  strcpy(pos_dat, argv[2]);

  ifstream fin1(pos_dat);
  if(!fin1) {
    cout << "Cannot open " << pos_dat << ".\n";
    return 1;
  }

  fin1 >> naxis1_in;
  fin1 >> naxis2_in;

  get_data = new double [naxis1_in * naxis2_in];
  if (!get_data) {
    cout << "Memory error.\n";
    return 2;
  }

  out_data = new double [naxis1_out * naxis2_out];
  if (!out_data) {
    cout << "Memory error.\n";
    return 2;
  }

/* open input fits file */

  strcpy (obs_frame, argv[1]);

  open_fitsfile(obs_frame, naxis1_in, naxis2_in, get_data);
  for (count1 = 0; count1 < naxis1_in * naxis2_in; count1++) {
    obs_data.push_back(get_data[count1] - bias);
    }

/* set output file name */

  dot_position = strrchr(obs_frame, '.');

  strncpy(out_frame, obs_frame, strlen(obs_frame) - strlen(dot_position));
  strcat(out_frame, "-image.fits");
  remove(out_frame);

/* calculate fiber flux */

  for(count1 = 0; count1 < num_fiber; count1++) {
    fin1 >> center_x;
    fin1 >> center_y;

    fiber_flux.push_back(func_box_flux(obs_data, naxis1_in, naxis2_in, center_x, center_y, center_range));

//    cout << "count1 = " << count1 << " fiber_flux = " << fiber_flux[count1] << "\n";
  }

/* fiber position library */

  for(count2 = 1; count2 <= 7; count2++) {
    for(count1 = 1; count1 < 7 + count2; count1++) {
      fiber_pos_x[count1 + tmp] = count1 * 2 + 6 - count2;
      fiber_pos_y[count1 + tmp] = 27 - count2 * 2;
    }
    tmp += count1 - 1;
//    cout << "tmp = " << tmp << "\n";
  }

  for(count2 = 1; count2 <= 6; count2++) {
    for(count1 = 1; count1 < 14 - count2; count1++) {
      fiber_pos_x[count1 + tmp] = count1 * 2 + count2 - 1;
      fiber_pos_y[count1 + tmp] = 13 - count2 * 2;
    }
    tmp += count1 - 1;
//    cout << "tmp = " << tmp << "\n";
  }

/* align in fiberbundle format */

  for(count1 = 0; count1 < naxis1_out * naxis2_out; count1++) out_data[count1] = 0;

  for(count1 = 0; count1 < num_fiber; count1++) {
    out_data[fiber_pos_x[fiber_id[count1]] - 1 + naxis2_out * (fiber_pos_y[fiber_id[count1]] - 1)] = fiber_flux[count1];
  }

/* output image file */

  create_fitsfile(obs_frame, out_frame, naxis1_out, naxis2_out, out_data);

  fin1.close();

  delete [] get_data;
  delete [] out_data;

  return 0;
}
