#include "Fiber_mn_MakeImage.h"

int main(int argc, char *argv[])
{
  if (argc != 6) {
    cout << "The number of argments does not match.\n";
    cout << "  Usage: Fiber_mn_MakeImage input_fits x_size y_size start_x end_x.\n";
    return 1;
  }

  int count1, count2, naxis_in[3];
  int naxis_out[3] = {0, atoi(argv[2]), atoi(argv[3])}, start_x = atoi(argv[4]) - 1, end_x = atoi(argv[5]) - 1;
  double *get_data, *out_data, sum_flux = 0;
  vector<double> obs_data;
  char obs_frame[char_length], out_frame[char_length], *dot_position;
  
  if (start_x > end_x) {
    cout << "start_x must be larger than end_x.\n";
    return 2;
  }

  out_data = new double [naxis_out[1] * naxis_out[2]];
  if (!out_data) {
    cout << "Memory error.\n";
    return 2;
  }

/* open input fits file */

  strcpy (obs_frame, argv[1]);

  get_naxis(obs_frame, naxis_in);

  get_data = new double [naxis_in[1] * naxis_in[2]];
  if (!get_data) {
    cout << "Memory error.\n";
    return 2;
  }

  open_fitsfile(obs_frame, naxis_in[1], naxis_in[2], get_data);
  for (count1 = 0; count1 < naxis_in[1] * naxis_in[2]; count1++) {
    obs_data.push_back(get_data[count1]);
  }

/* set output file name */

  dot_position = strrchr(obs_frame, '.');

  strncpy(out_frame, obs_frame, strlen(obs_frame) - strlen(dot_position));
//  strcat(out_frame, "-image.fits");
  sprintf(out_frame, "%s-image-%d-%d.fits", out_frame, start_x + 1, end_x + 1);
  remove(out_frame);

/* calculate flux */

  for (count1 = 0; count1 < naxis_out[1] * naxis_out[2]; count1++) {
    for (count2 = start_x; count2 < end_x; count2++) {
      sum_flux += obs_data[count2 + count1 * naxis_in[1]];
    }
    out_data[count1] = sum_flux;
    sum_flux = 0;
  }

/* output image file */

  create_fitsfile(obs_frame, out_frame, naxis_out[1], naxis_out[2], out_data);

  delete [] get_data;
  delete [] out_data;

  return 0;
}
